#include "externals.hh"
#include "globals.hh"

#include "filewatcher.hh"
#include "profiling.hh"
#include "texture.hh"
#include "shaders.hh"
#include "window.hh"
#include "odbg.hh"
#include "sync.hh"


std::unique_ptr< T_FilesWatcher > Globals::watcher_;
std::unique_ptr< T_Window > Globals::window_;
std::unique_ptr< T_Profiler > Globals::profiler_;
std::unique_ptr< T_SyncManager > Globals::sync_;
std::unique_ptr< T_TextureManager > Globals::textures_;
std::unique_ptr< T_ShaderManager > Globals::shaders_;
std::unique_ptr< T_OutputDebugger > Globals::odbg_;


void Globals::Init( )
{
	watcher_ = std::make_unique< T_FilesWatcher >( );
	window_ = std::make_unique< T_Window >( );
	profiler_ = std::make_unique< T_Profiler >( );
	sync_ = std::make_unique< T_SyncManager >( );
	textures_ = std::make_unique< T_TextureManager >( );
	shaders_ = std::make_unique< T_ShaderManager >( );
	odbg_ = std::make_unique< T_OutputDebugger >( );
}

void Globals::Shutdown( )
{
	odbg_.reset( );
	shaders_.reset( );
	textures_.reset( );
	profiler_.reset( );
	window_.reset( );
	watcher_.reset( );
}
